Public Slots | Public Member Functions | Protected Member Functions | Private Member Functions

# HDeviceHost Class Reference
[Device Hosting]

A class for creating and hosting `HDevice` instances on the network. More...

`#include <HDeviceHost>`

List of all members.

## Public Slots
void | quit ()
## Public Member Functions
| HDeviceHost (QObject *parent=0)
HDevice * | device (const HUdn &udn, HDevice::TargetDeviceType target=HDevice::RootDevices) const
HDevices | rootDevices () const
bool | init (const HDeviceHostConfiguration &configuration)
DeviceHostError | error () const
QString | errorDescription () const
bool | isStarted () const
## Protected Member Functions
const HDeviceHostConfiguration * | configuration () const
const HDeviceHostRuntimeStatus * | runtimeStatus () const
void | setError (DeviceHostError error, const QString &errorDescr)
## Private Member Functions
virtual bool | doInit ()
virtual void | doQuit ()
virtual bool | acceptSubscription (HService *targetService, const HEndpoint &source, bool isNew)

## Detailed Description

As the name implies, this is the class in the HUPnP library used to expose UPnP devices to UPnP control points. The class hosts instances of HDevice, which means that the class takes care of all of the UPnP mechanics detaching the HDevice from it. This separation leaves the HDevice to model the UPnP device structure and to focus on the functionality of the specific device type. This is what the HUPnP Device Model is all about.

Hosting a device is simple, assuming you have the necessary device and service descriptions ready and the HUPnP device and service classes implemented. Basically, you only need to:

- instantiate an HDeviceConfiguration for each UPnP device type to be hosted and pass them to the `HDeviceHost` inside a HDeviceHostConfiguration instance
- instantiate and initialize an `HDeviceHost`
- make sure a Qt event loop is present in the thread in which the `HDeviceHost` is run.

As an example, consider the following:

     // myclass.h

     #include <HUpnpCore/HDeviceHost>
     #include <QObject>

     class MyClass :
         public QObject
     {
     Q_OBJECT

     private:
         Herqq::Upnp::HDeviceHost* m_deviceHost;

     public:
         MyClass(QObject* parent = 0);
     };

     // myclass.cpp

     #include "myclass.h"
     #include "my_hdevice.h" // your code containing the type MyHDevice

     namespace
     {
     class Creator
     {
     public:
         Herqq::Upnp::HDevice* operator()(const Herqq::Upnp::HDeviceInfo&)
         {
             return new MyHDevice(); // your class derived from HDevice
         }
     };
     }

     MyClass::MyClass(QObject* parent) :
         QObject(parent),
             m_deviceHost(new Herqq::Upnp::HDeviceHost(this))
     {
         Herqq::Upnp::HDeviceConfiguration deviceConf;
         deviceConf.setPathToDeviceDescription("my_hdevice_devicedescription.xml");

         Creator deviceCreator;
         // You could also use a normal function or a member function to create
         // HDevice types.

         deviceConf.setDeviceCreator(deviceCreator);

         if (!m_deviceHost->init(deviceConf))
         {
             // The initialization failed, perhaps you should do something?
             // for starters, you can call error() to check the error type and
             // errorDescription() for a human-readable description of
             // the error that occurred.
             return;
         }

         // The host is running and your device should now be accessible to
         // UPnP Control points until the host is destroyed (assuming the current
         // thread has an event loop).
     }

There are a few noteworthy issues in the example above.

1. The device host will fail to initialize if your HDeviceConfiguration instance is invalid; for instance, the device creator is not specified or the path to your UPnP Device Description is invalid. Similarly, if your UPnP Device or UPnP Service description (if your UPnP device has one) is invalid, the device host will fail to initialize. The point is, you should always check the return value.
2. Your HDevice is accessible only as long as your `HDeviceHost` is alive. When the device host is destroyed every UPnP device it hosted are destroyed as well.
3. `HDeviceHost` requires an event loop to function.
4. `HDeviceHost` takes in a HDeviceHostConfiguration object, which has a constructor that takes in a HDeviceConfiguration object. This is exploited in the example above, since we are not interested in hosting multiple HDevice instances in the same host and we are not interested in modifying the default behavior of the `HDeviceHost`.
5. The example above uses an `HDeviceHost` instance to host a single UPnP root device, but the same host could be used to host multiple UPnP root devices. Certainly you can create multiple `HDeviceHost` instances that each host a single root HDevice within a thread, even sharing an event loop. However, using a single `HDeviceHost` for multiple root HDevice instances reduces resource usage in various ways and makes all the configured UPnP root devices accessible to you from the same `HDeviceHost` instance.

Remarks:

- `HDeviceHost` has thread affinity, which mandates that the `HDeviceHost` and any object managed by it must be destroyed in the thread in which the `HDeviceHost` at the time lives. You can use `QObject::moveToThread()` on the `HDeviceHost`, which causes the device host and every object managed by it to be moved to the chosen thread. However, you cannot move individual objects managed by `HDeviceHost`.

- `HDeviceHost` is the owner of the instances of `HDevice` it manages. It manages the memory of every object it has created. In other words, a device host never transfers the ownership of the HDevice objects it manages; HDeviceHost always destroys every HDevice it manages when it is being destroyed.

See also:
  Device Hosting, HDevice, HDeviceHostConfiguration, HDeviceConfiguration

## Member Enumeration Documentation

enum DeviceHostError

Specifies return values that some of the methods of the class may return.

Enumerator:

  UndefinedError | Return value signifying general failure. This return code is used when an operation could not be successfully completed, but the exact cause for the error could not be determined.
  AlreadyInitializedError | Return value signifying that the device host is already successfully initialized.
  InvalidConfigurationError | Return value signifying that the provided host configuration was incorrect.
  InvalidDeviceDescriptionError | Return value signifying that a provided device description document was invalid.
  InvalidServiceDescriptionError | Return value signifying that a provided service description document was invalid.
  CommunicationsError | Return value used to indicate one or more more problems in communications layer. For instance, perhaps the HTTP server or could the SSDP listener could not be initialized.

## Constructor & Destructor Documentation

HDeviceHost | ( | QObject * | parent = `0` | ) | `[explicit]`

Creates a new instance.

Parameters:

  | parent | specifies the parent `QObject`.

## Member Function Documentation

bool doInit | ( |  | ) | `[private, virtual]`

Performs the initialization of a derived class.

The `HDeviceHost` uses two-phase initialization in which the user first constructs an instance and then calls init() in order to ready the object for use. This method is called by the `HDeviceHost` during its private initialization after all the private data structures are constructed, but before any network operations are performed. At this point no HTTP or SSDP requests are served.

You can override this method to perform any further initialization of a derived class.

Returns:
  true if and only if the initialization succeeded. If false is returned the initialization of the device host is aborted. In addition, it is advised that you call setError() before returning.

Remarks:
  the default implementation does nothing.

See also:
  init()

void doQuit | ( |  | ) | `[private, virtual]`

Performs the de-initialization of a derived class.

Since it is possible to shutdown a device host without actually destroying the instance by calling quit(), derived classes have the possibility to run their own shutdown procedure by overriding this method. This method is called before the `HDeviceHost` cleans its private data structures but after it has stopped listening requests from the network.

Remarks:
  the default implementation does nothing.

See also:
  quit()

bool acceptSubscription | ( | HService * | targetService,
|  | const HEndpoint & | source,
|  | bool | isNew |
| ) |  |  | `[private, virtual]`

Checks if a (re-)subscription should be accepted.

Derived classes can opt to override this method to decide what event subscriptions are accepted and what are not.

Parameters:

  | targetService | specifies the target of the subscription.
  | source | specifies the location where the subscription came.
  | isNew | indicates the type of the subscription. The value is true in case the subscription is new and false in case the subscription is a renewal to an existing subscription.

Returns:
  true in case the subscription should be accepted.

Remarks:
  by default all subscriptions are accepted.

const HDeviceHostConfiguration * configuration | ( |  | ) | const`[protected]`

Returns the configuration used to initialize the device host.

Returns:
  the configuration used to initialize the device host or null in case the device host is not initialized.

Remarks:
  the returned object is not a copy and the ownership of the object is not transferred. Do not delete it.

const HDeviceHostRuntimeStatus * runtimeStatus | ( |  | ) | const`[protected]`

Returns the object that details information of the status of a device host.

Returns:
  the object that details information of the status of a device host.

Remarks:
  - A device host creates a single HDeviceHostRuntimeStatus object during construction and deletes it when the device host is being deleted.
  - The returned object is always owned by the device host.

void setError | ( | DeviceHostError | error,
|  | const QString & | errorDescr |
| ) |  |  | `[protected]`

Sets the type and description of the last error occurred.

Parameters:

  | error | specifies the error type.
  | errorDescr | specifies a human readable description of the error.

See also:
  error(), errorDescription()

HDevice * device | ( | const HUdn & | udn,
|  | HDevice::TargetDeviceType | target = `HDevice::RootDevices` |
| ) |  |  | const

Returns a root device with the specified Unique Device Name.

Parameters:

  | udn | specifies the Unique Device Name of the desired root device.
  | target | specifies the type of devices that are included in the search.

Returns:
  the root device with the specified Unique Device Name, or a null pointer in case no currently managed root device has the specified UDN.

Warning:
  the returned device will be deleted when the device host is being destroyed. However, do not delete the device object directly. The ownership of an HDevice is never transferred.

HDevices rootDevices | ( |  | ) | const

Returns a list of UPnP root devices the host is currently managing.

The returned list contains pointers to root HDevice objects that are currently hosted by this instance.

Returns:
  a list of pointers to root HDevice objects that are currently managed by the device host.

Warning:
  the returned HDevice instances will be deleted when the device host is being destroyed. However, do not delete the device objects directly. The ownership of an HDevice is never transferred.

bool init | ( | const HDeviceHostConfiguration & | configuration | ) |

Initializes the device host and the devices it is supposed to host.

Parameters:

  | configuration | specifies the configuration for the instance. The object has to contain at least one device configuration.

Returns:
  true if the initialization of the device host succeeded. If false is returned you can call error() to get the type of the error, and you can call errorDescription() to get a human-readable description of the error.

See also:
  quit()

HDeviceHost::DeviceHostError error | ( |  | ) | const

Returns the type of the last error occurred.

Returns:
  the type of the last error occurred.

QString errorDescription | ( |  | ) | const

Returns a human readable description of the last error occurred.

Returns:
  a human readable description of the last error occurred.

bool isStarted | ( |  | ) | const

Indicates whether or not the host is successfully started.

Returns:
  true in case the host is successfully started.

void quit | ( |  | ) | `[slot]`

Quits the device host and destroys the UPnP devices it is hosting.

Note that this is automatically called when the device host is destroyed.

Attention:
  Every pointer to object retrieved from this instance will be deleted. Be sure not to use any such pointer after calling this method.

See also:
  init()